;
;                    Scrolling Routines by CrASH_Man                02/14/98
;
;
;   This is some example source for CrASH v1.3 to test the scrolling
; routines inside SCROLL.ASM.
;
;   Hit keys and the screen will scroll up, down, left, then right.
;
;                                                               by CrASH_Man

.INCLUDE CrASH82.INC
.DB "Scroll Test", 0

  CALL MakeScreen
  LD  B, 64                     ; Scroll vertically 64 times
ULoop:
  CALL Scroll_U                 ; Scroll up
  CALL CR_GRBCopy
  DJNZ ULoop
  CALL MakeScreen
  LD  B, 64
DLoop:
  CALL Scroll_D                 ; Scroll down
  CALL CR_GRBCopy
  DJNZ DLoop
  CALL MakeScreen
  LD  B, 96
LLoop:
  CALL Scroll_L                 ; Scroll left
  CALL CR_GRBCopy
  DJNZ LLoop
  CALL MakeScreen
  LD  B, 96
RLoop:
  CALL Scroll_R                 ; Scroll right
  CALL CR_GRBCopy
  DJNZ RLoop

  RET

MakeScreen:                     ; Fill the screen with random pixels
  LD  HL, GRAPH_MEM             ; Fill GRAPH_MEM
  LD  B, 0                      ; 256 times -- Each time we do 3 bytes
FillLoop:
  CALL RAND \ RLA               ; 8-bit number
  LD  (HL), A                   ; Save it
  INC HL                        ; Point to next byte in GRAPH_MEM
  CALL RAND \ RLA
  LD  (HL), A
  INC HL
  CALL RAND \ RLA
  LD  (HL), A
  INC HL
  DJNZ FillLoop

  CALL CR_GRBCopy               ; Display
  CALL CR_KHAND                 ; Wait for a key
  RET

.INCLUDE SCROLL.ASM             ; These are the scrolling routines.
